package net.locusworks.common.immutables;

/**
 * Class that holds three immutable objects as triplets
 * @author Isaac Parenteau
 * @version 1.0.0 
 * @param <V1> class type of object 1
 */
public class Unit<V1> {
  
  private V1 value1;
  
  /**
   * Default constructor with no values
   */
  public Unit() {}
  
  /**
   * Constuctor
   * @param value1 value 1
   */
  public Unit(V1 value1) {
    this.value1 = value1;
  }
  
  /**
   * Set value 1
   * @param value1 value 1
   */
  public void setValue1(V1 value1) {
    this.value1 = value1;
  }
  
  /**
   * Get value 1
   * @return value1
   */
  public V1 getValue1() {
    return value1;
  }
  
  @Override
  public boolean equals(Object other) {
    if (!(other instanceof Unit)) return false;
    
    Unit<?> otherUnit = (Unit<?>)other;
    
    return this.getValue1().equals(otherUnit.getValue1());
  }
}